=== Modules/Bridge/VTK/CMakeLists.txt ===
project(ITKVTK)
set(ITKVTK_LIBRARIES ITKVTK)
itk_module_impl()
