=== debian/changelog ===
insighttoolkit4 (4.9.0-4ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build with parallel=2 on amd64.
    - Build on all architectures.
    - Ignore test results on architectures other than amd64 and i386 for
      a first build (and print test failures).
    - debian/rules: Use HOST instead of BUILD macros.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Feb 2016 10:06:51 +0100

insighttoolkit4 (4.9.0-4) unstable; urgency=medium

  * d/control.in, d/control: Change to libdcmtk-dev depends in all places
    Closes: #812192

 -- Gert Wollny <gw.fossdev@gmail.com>  Sat, 27 Feb 2016 17:32:03 +0000

insighttoolkit4 (4.9.0-3ubuntu2) xenial; urgency=medium

  * Build with parallel=2 on amd64 again.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 24 Feb 2016 16:46:59 +0100

insighttoolkit4 (4.9.0-3ubuntu1) xenial; urgency=medium

  * Merge from Debian unstable (fix previous upload).  Remaining changes:
    - Build on all architectures.
    - Ignore test results on architectures other than amd64 and i386 for
      a first build (and print test failures).
    - debian/rules: Use HOST instead of BUILD macros.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 23 Feb 2016 18:33:13 +0100

insighttoolkit4 (4.9.0-3) unstable; urgency=medium

  * d/control.in: Add libdouble-conversion-dev to libinsightoolkit4-dev dependencies
  * d/control.in: Change build-dependency to libpng-dev, NMU got lost with the update

 -- Gert Wollny <gw.fossdev@gmail.com>  Tue, 23 Feb 2016 16:50:32 +0000

insighttoolkit4 (4.9.0-2ubuntu2) xenial; urgency=medium

  * Merge from Debian unstable (fix previous upload).  Remaining changes:
    - Build on all architectures.
    - Ignore test results on architectures other than amd64 and i386 for
      a first build (and print test failures).
    - debian/rules: Use HOST instead of BUILD macros.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 22 Feb 2016 11:14:53 +0100

insighttoolkit4 (4.9.0-2ubuntu1) xenial; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Build with parallel=8 on amd64.
    - Build on all architectures.
    - Ignore test results on architectures other than amd64 and i386 for
      a first build (and print test failures).
    - debian/rules: Use HOST instead of BUILD macros.
  * Drop intrinsics patch: upstream.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 22 Feb 2016 10:17:43 +0100

insighttoolkit4 (4.9.0-2) unstable; urgency=medium

  * d/p: add patch atomic_load.patch to make atomic Load 
    operation truly atomic
  * d/p: add patch flatStructuringElementTest_fix_rescale.patch 
    Closes: #814591
  * d/p: add patch ITKv3MultiResImageRegistrationTest_correct.patch
    to stabelize this test 
  * d/control: update castxml dependency 

 -- Gert Wollny <gw.fossdev@gmail.com>  Sun, 21 Feb 2016 20:29:30 +0000

insighttoolkit4 (4.9.0-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build with parallel=4 on amd64.
    - Build on all architectures.
    - Ignore test results on architectures other than amd64 and i386 for
      a first build (and print test failures).
    - debian/rules: Use HOST instead of BUILD macros.
  * Drop intrinsics patch: upstream.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Feb 2016 10:02:40 +0100

insighttoolkit4 (4.9.0-1) unstable; urgency=medium

  * New upstream version  Closes:  #811809
  * d/control: change libinsighttoolkit4-dev depends to use unversioned libdcmtk-dev
    Closes: #812192
  * d/control: set minimal version of libdcmtk-dev because of cmake woes 
    Closes: #810044
  * d/control: Set minimal version of castxml required for #811809
  * d/rules: disable printing out test log, since failed test now print their 
    error log during the test run. 
  * d/control: use system double-conversion Closes: #733629
  * d/rules: explicitely disable KWStyle, because otherwise it wants to download 
  * d/rules: remove line for installing Python related *.so files. They are 
    now installed under pythonVER/site-packages 
  * d/control*: Update standards version to 3.9.7
 
 -- Gert Wollny <gw.fossdev@gmail.com>  Mon, 1 Feb 2016 12:33:38 +0100

insighttoolkit4 (4.8.2-3.1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build again sequentially on amd64. Build still fails, and there is
      no build log left in launchpad.
    - Build with parallel=2 on amd64.
    - Build on all architectures.
    - Ignore test results on architectures other than amd64 and i386 for
      a first build.
    - debian/rules: Use HOST instead of BUILD macros.
    - Fix build with castxml.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 28 Jan 2016 14:46:33 +0100

insighttoolkit4 (4.8.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Change B-D to libpng-dev for libpng 1.6 transition (Closes: #810185)

 -- Tobias Frost <tobi@debian.org>  Tue, 19 Jan 2016 07:28:31 +0100

insighttoolkit4 (4.8.2-3) unstable; urgency=medium

  * Tighten dependency on libdcmtk-dev to alliviate #810044

 --  <gw.fossdev@gmail.com>  Wed, 06 Jan 2016 11:00:19 +0000

insighttoolkit4 (4.8.2-2) unstable; urgency=medium

  * Restrict dependencies to use gdcm-2.6 >= 2.6.1-3 or gdcm-2.4
    Closes: #808491

 -- Gert Wollny <gw.fossdev@gmail.com>  Wed, 21 Dec 2015 18:03:56 +0100

insighttoolkit4 (4.8.2-1) unstable; urgency=medium

  * New upstream 
  * d/control: Change dependency to un-versioned libdcmtk-dev 
    Closes: #804575
  * s/control: Set minimal version of libdcmtk-dev, because this 
    version will pull in libxml2-dev and libssl-dev that are 
    required for linking 
  * s/control: Add libcharls-dev to the dependencies. 

 -- Gert Wollny <gw.fossdev@gmail.com>  Mon, 30 Nov 2015 10:17:55 +0100

insighttoolkit4 (4.8.1-1ubuntu4) xenial; urgency=high

  * No change rebuild against gdcm2.6.


