=== debian/watch ===
version=3
http://sf.net/itk/InsightToolkit-(.*)\.tar\.xz
